/**************************************************************************
 * HeXHub Messenger Plugin Copyright (C) 2007-2008 Mikhail Polenin        *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This plugin is licensed under the Open Software License 3.0            *
 * Please read the license before making a modification to this plugin.   *
 * Failure to follow the terms of the license will have severe            *
 * consequences                                                           *
 **************************************************************************/

#include <string>
#include <sstream>
#include "windows.h"
#define memcpywithnull(dst, src, size) memcpy(dst, src, size); dst[size] = NULL;
#define MAX_NICK 40
#define MAX_BUFFER 32768
#define MAX_READ sizeof(secstruct)

struct box {
		char nick[40];
		DWORD amtofmessages;
		BOOL PMNotify;
		box *next;
		box *prev;
		box()
		{
			PMNotify = 0;
			amtofmessages = 0;
			next=NULL;
			prev=NULL;
		}
	};

struct secstruct {
		char nick[MAX_NICK];
		DWORD AmtofMessages;
		DWORD reserved1;
		DWORD reserved2;
		char reserved3[512];
		DWORD reserved4;
		BOOL PMNotify;
		BOOL reserved5;
		BOOL reserved6;
		char reserved7[1024];
	};

class Mailbox
{
private:
	box *first;
	box *last;
	unsigned int total;
	CRITICAL_SECTION mbcs;
public:	
	Mailbox(void);
	~Mailbox(void);
	BOOL Add(char *nick);
	BOOL Add(secstruct temp);
	BOOL AppendMsg(std::string msg, char *nick, char *fromnick);
	BOOL AddMsg(std::string msg, char *nick, char *fromnick);
	std::string GetFileSafeString(char *str);
	std::string GetNickFromFileSafeString(char *str);
	std::string GetMessages(char *nick);
	BOOL ClearMailbox(char *nick);
	BOOL Find(char *nick);
	box *FindBox(char *nick);
	BOOL SaveConfig();
	BOOL LoadConfig();
};